navigator.getUserMedia = (
     navigator.getUserMedia
  || navigator.mozGetUserMedia
  || navigator.webkitGetUserMedia
  || navigator.msGetUserMedia
 );

function connection(cfg) {
  try {
    return new webkitRTCPeerConnection(cfg);
  } catch(e) {
    try {
	  return new mozRTCPeerConnection(cfg);
    } catch (e) {
	  return new RTCPeerConnection(cfg);
	}
  } 
}

function description(desc) {
  try {
    return new webkitRTCSessionDescription(desc);
  } catch(e) {
    try {
	  return new mozRTCSessionDescription(desc);
    } catch (e) {
	  return new RTCSessionDescription(desc);
	}
  } 
}

function icecandidate(cand) {
  try {
    return new webkitRTCIceCandidate(cand);
  } catch(e) {
    try {
	  return new mozRTCIceCandiadate(cand);
    } catch (e) {
	  return new RTCIceCandidate(cand);
	}
  } 
}

function onice(pc) {
  return function(evt) {
    if (evt.candidate) {
      pc.addIceCandidate(icecandidate(evt.candidate));
    }
  }
}

function onice2(channel) {
  return function(evt) {
    if (evt.candidate) {
      send(channel, {command:"ice", data:evt.candidate});
    }
  }
}

function desc(pc, channel, comm) {
  return function(desc) {
    pc.setLocalDescription(desc);
    send(channel, {command:comm, data:desc});
  };
}


function onadd() {
  return function(evt) {
    connectStream(evt.stream, "#remote");
  }
}    

function connectStream(stream, query) {
 console.log(query);
 var ele = document.querySelector(query);
 if (ele) {
  if (navigator.webkitGetUserMedia) {
   ele.src = window.URL.createObjectURL(stream);
  } else if (navigator.mozGetUserMedia) {
   ele.mozSrcObject = stream;
  } else {
   ele.src = stream;
  }
  ele.play();
 }	
};

function error(err) {
 document.getElementById("msg").textContent=err;
}

function send(channel, msg) {
  console.log("sending "+JSON.stringify(msg));
  channel.send(JSON.stringify(msg));
}

function data(pc, opener) {
  if (opener) {
    config(pc.createDataChannel("work"));
  } else {
    pc.ondatachannel = function(evt) {
      config(evt.channel);
    }
  }
}  

function config(channel) {
  channel.onmessage = function(evt) {
    console.log(evt.data);
    channel.send("recived message");
  }
}
